/** 
 * @page I/O
 *
 * <h3> I/O </h3>
 *
 * There are two I/O drivers in our system: keyboard and printer.
 *
 * Printer is very simple device - it just prints characters that we put on its
 * address. Printer synchronization is ensured by mutex.
 *
 * Keyboard is a little bit more complicated. System holds a system buffer which
 * stores all the input from keyboard. This is a cyclic buffer so when nobody reads
 * it for a long time, the oldest characters are overwritten by the newest.
 * When some process tries to read from the buffer, it gets the characters inside
 * and the buffer rotates to the next chars. When there are no characters in the
 * buffer and some thread wants to read, it is blocked until there is some input.
 *
 * @link kernel/drivers/keyboard.h Keyboard implementation @endlink
 *
 * @link kernel/drivers/printer.h Printer implementation @endlink
 *
 * @link user/librt/io.h User I/O implementation @endlink
 *
 * @see getc
 * @see gets
 * @see printk
 * @see puts
 * @see putc 
 */
