/** 
 * @page Hashmap
 *
 * <h3> The hashmap structure </h3>
 *
 * In order that we can check the validity of user structures (e.g. threads or mutexes) we use the hashmap structure. 
 * The hashmap we use was originally written by Elliot C. Back, then modified by Pete Warden to fix a serious 
 * performance problem, support strings as keys and remove thread synchronization. For our purposes we modified the 
 * interface to support long integers (~pointer) as keys.
 *
 * @link kernel/adt/hashmap.h Hashmap implementation @endlink
 *
 * @see http://elliottback.com/wp/hashmap-implementation-in-c/
 * @see https://github.com/petewarden/c_hashmap
 * @see crc32
 * @see hashmap_new
 * @see hashmap_iterate
 * @see hashmap_put
 * @see hashmap_get
 * @see hashmap_remove
 * @see hashmap_get_one
 * @see hashmap_free
 * @see hashmap_length
 */
