/**
 * @mainpage Main Page
 *
 * <h1>@section Introduction</h1>
 *
 * The operating system DrHaUr was implemented as a part of the semestral course Operating systems at Faculty of Mathematics 
 * and Physics of Charles University in Prague. 
 *
 * The system was developed in 3 basic assignments and one selected extended assignment. The first basic assignment consists of 
 * simple support of bootstrap, debug tools, interrupt and exception handling, kernel threads structure and synchronization 
 * primitives. The following second basic assignment added the frame allocator and simple virtual memory manager with translation 
 * fault handler (TLB). Finally, with the final third basic assignment was implemented userspace support with syscall calling.
 * As the extended assignment was choosen MultiCPU support.
 * 
 * Detailed information about particular components of the system can be found in the following section. 
 * 
 * 
 * <h2>@subsection Subsystems</h2> 
 * 
 * <ul>
 *   <li>@link Malloc @endlink</li>
 *   <li>@link I/O @endlink</li>
 *   <li>@link Scheduler @endlink</li>
 *   <li>@link sync Synchronization @endlink</li>
 *   <li>@link Syscalls @endlink</li>
 *   <li>@link Threads @endlink</li>
 *   <li>@link Timer @endlink</li>
 *   <li>@link TLB_ASID   TLB & ASID @endlink</li>
 *   <li>@link vmm  Virtual Memory Manager @endlink</li>
 *   <li>@link Virtual_Malloc  Virtual Malloc @endlink</li>
 *   <li>@link IPI Interprocessor Interrupts @endlink</li>
 * </ul>
 * 
 * <h2>@subsection Data structures</h2>
 * <ul>
 *   <li>@link list Linked list @endlink</li>
 *   <li>@link sync_list  Synchronized list @endlink</li>
 *   <li>@link nblock_list  Non-blocking list @endlink</li>
 *   <li>@link Hashmap @endlink</li>
 * </ul>
 *
 */

