/** 
 * @page Malloc
 *
 * <h3> Malloc </h3>
 *
 * Blocks allocated on heap by malloc have headers which keeps some information
 * about that blocks. Each header contains size of block, flag that indicates if
 * the block is free and addresses of the next and previous blocks.
 *
 * When new block should be allocated, the system tries to find the first free
 * block which size is greater or equal to the size of the allocated block plus
 * its header. In case that such block is found, it is split to the new allocated
 * block and the rest which remains free (or there will be no rest if the 
 * allocated block is big enough). If no suitable block is present, system 
 * allocates new block with requested size rounded up for whole memory pages.
 *
 * In case of freeing some block, it is firstly joined with adjacent free blocks.
 * Then, if the new free big block (created by joining of 1-3 blocks) contains
 * at least one whole memory page (not only by size but also by alignment), that
 * pages are freed and blocks are split according to it.
 *
 * There can be made some optimalizations in this algorithms (e.g. using next fit
 * instead of first fit or not free immediately all pages that can be freed
 * because that pages can be reused in a short time). Unfortunately, there was no
 * time to implement this.
 *
 * @link kernel/mm/malloc.n Kernel malloc implementation @endlink
 *
 */
