/** 
 * @page nblock_list
 *
 * <h3> Non-blocking list </h3>
 *
 * We implemented the non-blocking list described by Timothy L. Harris. That study describes implementation of non-blocking 
 * concurrent linked-lists supporting linearizable insertion and deletion operations. In order that we can compare the 
 * execution speed performance of the structure we designed the global synchronized list as the opponent in the comparison.
 * @link kernel/adt/nblock_list.h Non-blocking list implementation @endlink
 *
 * We designed the simple benchmark so that we can dispose a study of speed comparison.
 * @link kernel/tests/list/benchmark/test_nblock.c Benchmark for non-blocking list implementation @endlink
 *
 * @link doc/files/nblock_study.pdf Speed comparison of non-blocking algorithm @endlink
 *
 * @link doc/files/app_res.csv Results of speed comparison @endlink
 * 
 * @see http://research.microsoft.com/en-us/um/people/tharris/papers/2001-disc.pdf
 */
