/** 
 * @page Scheduler
 *
 * <h3> Scheduler </h3>
 *
 * Scheduler in our system is based on the original Kalisto scheduler. It has seperate lists of
 * runnable threads on each CPU. It's round-robin scheduler and plans threads one by one without
 * any priorities. 
 *
 * There is a special idle / timer thread which serves two purposes in the system. It always stays
 * in the runnable threads so in case there are no other threads to run, this one can be always scheduled.
 * It also handles timer handler and runs them when they are ready.
 *
 * Threads are assigned to CPU in time of their creation. There is no support for moving threads
 * across CPUs. Scheduler tries to fairly plan threads on CPUs. It has a varible indicating on 
 * which CPU was the last thread planned and uses next available CPU.
 *
 * @link kernel/sched/sched.h Scheduler implementation. @endlink
 *
 * @see init_scheduler
 * @see init_scheduler_cpu
 * @see enqueue
 * @see dequeue
 * @see schedule
 * @see sched_timer
 */
