/** 
 * @page sync_list
 *
 * <h3> Global synchronized list. </h3>
 
 * In order that we can compare the execution speed performance of the non-blocking algorithm described by Timothy 
 * L. Harris, we designed the global synchronized list as the opponent in the comparison. For this reason the 
 * interface of the structure must be identical as the non-blocking list interface. The structure is synchronized 
 * by one global mutex locked until the operation with the list end. We designed the simple benchmark so that we can 
 * dispose a study of speed comparison.
 * @link kernel/adt/sync_list.h Global synchronized list implementation @endlink
 *
 * We designed the simple benchmark so that we can dispose a study of speed comparison.
 * @link kernel/tests/list/benchmark/test_sync.c Benchmark for global synchronized list implementation @endlink
 *
 * @link doc/files/nblock_study.pdf Speed comparison of non-blocking algorithm @endlink
 *
 * @link doc/files/app_res.csv Results of speed comparison @endlink 
 */
