/** 
 * @page Threads
 *
 * <h3> Threads </h3>
 *
 * Each thread belongs either into kernel or into userland.
 *
 * Kernel threads have only one context which execute envelope function in which
 * is firstly executed thread main function and then function which finishes the
 * thread which turns it to zombie (if attached) or destroy the
 * thread (if detached).
 *
 * NOTE: A bug was found in freeing threads in code revision. When a detached 
 * thread is freeing itself, it frees its stack in which is still running. The
 * bug have not apeared in tests because the memory with stack have not been
 * allocated before the thread ends (the critical moment is very short). Due to
 * disabling thread from scheduler before it frees itself, it can also cause
 * memory leaks. This bug (or both bugs) can be fixed by creating special thread
 * which can free all threads that are supposed to be free. The bug is still 
 * there in code because it was found very late, just before deadline, and there
 * was no time to fix it.
 *
 * Thread sleeping is realized by timers - a thread disables itself and starts
 * a timer which wakes the thread up when the time comes. For long sleeps the timer
 * is able to reset itself to run again (there is a counter which remembers how
 * many times should be that timer reseted).
 *
 * When there is a sleeping thread which waits for joining another thread, it is
 * awaken when the joined thread finishes. Joining thread can read any data from
 * joined thread and then frees it.
 *
 * When userland thread is created, its userland stack is allocated. Kernel stack
 * of that thread is set to execute syscall handling; userland stack is set to
 * execute threads code. All thread functions like join, sleep etc. are realized
 * by syscalls (e.g. while kernel part of some thread is sleeping, userland part
 * cant be executed because the thread is switched to the kernel stack).
 *
 * @link kernel/proc/thread.h Kernel thread implementation @endlink
 *
 */
