/**
 * @page Timer
 *
 * <h3> Timer </h3>
 *
 * Timer support is built on top of scheduler. Kernel keeps queues 
 * of started timers separately for each CPU. Every time scheduler is switching
 * threads after hardware timer interrupt or explicit call it adjusts "running"
 * timers remaining time. If there's any expired timer, scheduler switches to 
 * a special timer worker thread which runs timer handler. Timers manipulation should
 * be handled locally on each CPU, cross CPU access is not supported.
 *
 * Functions ending with suffix _queue were meant as helper functions.
 * Our plan was to have multiple queues for different timer types. 
 * For example short or long timers, also timers which would be started 
 * in its own thread or specified thread's context so they could access virtual memory.
 * Later this idea was not implemented due to lack of time.
 *
 * @link kernel/drivers/timer.h Timer implementation @endlink
 *
 * @see init_timer
 * @see init_timer_cpu
 * @see timer_init
 * @see timer_start
 * @see timer_destroy
 * @see timer_pending
 * @see timer_ticks
 * @see timer_ready
 */ 
