/**
 * @page TLB_ASID
 * 
 * <h3> Translation Lookaside Buffer and Address Space IDentifier </h3>
 *
 * Translation lookaside buffer in our system is filled with random
 * replacement algorithm. 
 *
 * To be able to clear specific entries fast enough
 * there is a structure @link tlb @endlink which keeps actual mirror copy
 * of processor TLB. It contains virtual pages and ASIDs.
 *
 * ASIDs are assigned to thread on every schedule. Thread keeps the same ASID 
 * as long as it's possible. When all ASIDs are used, it's taken from other
 * thread. For simplier debugging purposes mainly in the steady developing of 
 * virtual memory, ASID #255 was selected as unused one and no thread does use it.
 *
 * @link kernel/mm/tlb.h TLB implementation @endlink
 *
 * @see init_tlb
 * @see init_tlb_cpu
 * @see tlb_clear
 * @see tlb_clear_local
 * @see tlb_clear_asid
 * @see tlb_clear_local_asid
 * @see tlb_clear_range
 * @see tlb_clear_local_range
 * @see wrapped_tlbrefill
 * @see get_virtual_space
 */ 
