/**
 * @page Virtual_Malloc
 *
 * <h3> Virtual malloc </h3>
 *
 * Virtual malloc is entirely based on the kernel heap allocator. It uses 
 * the same data structures and the same algorithm. There are however some
 * minor differences.
 *
 * There is not just single virtual heap start but every thread owns one
 * followed by virtual heap lock which restricts access to it.
 * 
 * Virtul malloc doesn't directly call @link frame_alloc @endlink but it uses 
 * @link vma_map @endlink and @link vma_unmap @endlink among the others virtual
 * memory functions. 
 *
 * Function @link vma_map @endlink is called only giving flag @link VM_SAFE_RANGE @endlink
 * which garanties that first few pages are not used. This is used for safety reasons
 * so that virtual heap start can't be allocated to virtual adress 0, for that may 
 * cause serious troubles when comparing virtual pointers to NULL. 
 *
 * @link kernel/mm/vmalloc.h Virtual malloc implementation @endlink
 *
 * @see virtual_malloc
 * @see virtual_free
 * @see VM_SAFE_RANGE
 */ 
