/**
 * @file api.h
 *
 * API for kernel tests
 *
 * Kalisto
 *
 * Copyright (c) 2001-2010
 *   Department of Distributed and Dependable Systems
 *   Faculty of Mathematics and Physics
 *   Charles University, Czech Republic
 *
 */

#ifndef API_H_
#define API_H_

#define va_arg 		__builtin_va_arg
#define va_end 		__builtin_va_end
#define va_start 	__builtin_va_start
#define va_list 	__builtin_va_list

#include <include/shared.h>
#include <include/c.h>

#include <drivers/printer.h>
#include <mm/malloc.h>
#include <mm/utils.h>
#include <mm/tlb.h>
#include <adt/atomic.h>
#include <adt/sync_list.h>
#include <adt/nblock_list.h>
#include <drivers/timer.h>
#include <proc/thread.h>
#include <exc/assert.h>
#include <sync/mutex.h>
#include <drivers/keyboard.h>
#include <drivers/dtime.h>
#include <sync/rwlock.h>
#include <sync/spinlock.h>
#include <sync/semaphore.h>
#include <sync/cvar.h>
#include <mm/physmem.h>
#include <mm/vmm.h>

/* Run the kernel test */
extern void run_test (void);



#endif
