/**
 * @file dtime.h
 *
 * Dtime device support.
 *
 */

#ifndef DTIME_H_
#define DTIME_H_

#include <exc/assert.h>
#include <include/c.h>
#include <include/shared.h>

#define DTIME_ADDRESS  (ADDR_IN_KSEG1 (DEVICE_DTIME_ADDR))


/**
 * Get current real hardware time. 
 */
static inline uint32_t time (void)
{
	return (*(volatile uint32_t *) DTIME_ADDRESS);
}


/** 
 * Get estimated CPU ticks per second.
 */
uint32_t ticks_per_second (void);

#endif

