/**
 * @file keyboard.h
 *
 * Keyboard driver.
 *
 */

#ifndef KEYBOARD_H_
#define KEYBOARD_H_

#include <include/c.h>

/** keyboard buffer size */
#define KEYBOARD_BUFFER_SIZE 4096

/** Base address of the keyboard hardware */
#define KEYBOARD_ADDRESS  (ADDR_IN_KSEG0 (0x10000000))

/* keyboard initialization */
void keyboard_init (void);

/* function for getting chars from buffer */
char    getc     (void                  );
char    getc_try (void                  );
ssize_t gets     (char * str, size_t len);

/* function for transfering chars into buffer while interrupt from keyboard */
void keyboard_interrupt (void);

#endif