/**
 * @file printer.h
 *
 * Simple console support.
 *
 */


#ifndef PRINTER_H_
#define PRINTER_H_


#include <include/shared.h>
#include <include/c.h>


/** Base address of the console hardware */
#define PRINTER_ADDRESS  (ADDR_IN_KSEG0 (0x10000000))


/* initialization */
void printer_init (void);

/* prints with variadic list */
extern size_t printk_variadic_list (const char * fst, __builtin_va_list variadic_args);

/* sync prints */
extern size_t putc   (const char   chr     );
extern size_t puts   (const char * str     );
extern size_t printk (const char * fst, ...);


/* not sync prints */
extern size_t putc_not_sync   (const char   chr     );
extern size_t puts_not_sync   (const char * str     );
extern size_t printk_not_sync (const char * fst, ...);


/* Externals are commented with implementation */
extern void print (const char *text);

#endif
