/**
 * @file int.h
 *
 * Interrupt handling.
 *
 * Kalisto
 *
 * Copyright (c) 2001-2010
 *   Department of Distributed and Dependable Systems
 *   Faculty of Mathematics and Physics
 *   Charles University, Czech Republic
 *
 */

#ifndef INT_H_
#define INT_H_


#include <adt/atomic.h>
#include <sync/spinlock.h>


context_t* current_registers;

/** Cause of inter process interrupt is panic.
 */
ATOMIC_EXTERN( ipi_panic);

/** Cause of inter process interrupt.
 */
ATOMIC_EXTERN( ipi_cause);

/** 
 */
struct spinlock ipi_cause_lock;	

/* Externals are commented with implementation */
extern void interrupt (context_t *registers);


#endif
