#! /bin/sh

#
# Kalisto
#
# Copyright (c) 2001-2010
#   Department of Distributed and Dependable Systems
#   Faculty of Mathematics and Physics
#   Charles University, Czech Republic
#
# Parse the assembler source code generated from
# compiling gen_offset.c and create offset.h.
#

echo "/**"
echo " * @file offset.h"
echo " *"
echo " * Stack frame offsets."
echo " *"
echo " * Do not modify. This file was generated by gen_offset.sh"
echo " * from gen_offset.c."
echo " *"
echo " */"
echo ""
echo "#ifndef OFFSET_H_"
echo "#define OFFSET_H_"
echo ""

awk '
BEGIN {
	OFS="\t"
}

/^#DECLARE#/ {
	gsub("#DECLARE#\t", "");
	print $0
}' "$1"

echo ""
echo "#endif /* OFFSET_H_ */"
