/**
 * @file malloc.h
 *
 * Kernel memory allocator.
 *
 */

#ifndef MALLOC_H_
#define MALLOC_H_


#include <include/c.h>


/** Address of kernel image end.
 *
 * The symbol containing the last address of the kernel image is provided by
 * the linker, see the linker script for details of how this is done.
 *
 */
extern uint8_t _kernel_end;

/* Externals are commented with implementation */
extern void init_memory (void);
extern void *malloc (const size_t size);
extern void *safe_malloc (const size_t size);
extern void free (const void *ptr);

#endif
