/**
 * @file sched.h
 *
 * Round-robin multiprocessor kernel thread scheduler.
 *
 */

#ifndef SCHED_H_
#define SCHED_H_


#include <adt/atomic.h>
#include <drivers/timer.h>
#include <proc/thread.h>


/* Commented with implementation */

ATOMIC_EXTERN(cpu_ready);

void 		init_scheduler (void);
thread_t 	init_scheduler_cpu (void);
void 		start_scheduler_cpu (void);
void 		enqueue (thread_t thread);
void 		dequeue (thread_t thread);
void 		schedule (uint32_t cpu);

void runnable (thread_t thread);
void disabled (thread_t thread);
void scheduled (void);

#endif
