/**
 * @file spinlock.h
 *
 * Active synchronization primitive ensures atomicity for higher primitives.
 *
 */


#ifndef SPINLOCK_H_
#define SPINLOCK_H_


#include <include/shared.h>
#include <include/c.h>


/** structure for spinlock */
struct spinlock
{
	/* 0 is unlocked, 1 is locked */
	native_t lock;
};


/* initialization of spinlock structure */
void spinlock_init    (struct spinlock * splk);


/* freeing of spinlock structure */
void spinlock_destroy (struct spinlock * splk);


/* locking spinlock */
void spinlock_lock    (struct spinlock * splk);


/* unlocking spinlock */
void spinlock_unlock  (struct spinlock * splk);


#endif