#! /bin/bash

#
# List benchmark 
# Compile and boot with tests for extended assignment 1.

fail() {
	rm -f test.log
	echo
	echo "Failure: $1"
	exit 1
}

# Don't output command executed by make unless run with -v
if [ "$1" == "-v" ] ; then
	SILENT_MAKE=""
else
	SILENT_MAKE="--silent"
fi

emake() {
	echo "Running make $SILENT_MAKE $@"
	make $SILENT_MAKE "$@"
}

echo " *** Non-interactive tests ***"

for TEST in \
	tests/list/benchmark/test_sync.c \
	tests/list/benchmark/test_nblock.c \
	; do
	emake distclean || fail "Cleanup before compilation"
	emake "KERNEL_TEST=$TEST" || fail "Compilation"
	msim | tee test.log || fail "Execution"
	rm -f test.log
	emake distclean || fail "Cleanup after compilation"
done
