/**
 * @file syscall.h
 *
 * definitions of syscall numbers
 *
 * Kalisto
 *
 */

#ifndef KU_SYSCALL_H_
#define KU_SYSCALL_H_


#define SYSCALL_THREAD_CREATE		1
#define SYSCALL_THREAD_SELF 	  	2
#define SYSCALL_THREAD_JOIN		3
#define SYSCALL_THREAD_JOIN_TIMEOUT	4
#define SYSCALL_THREAD_DETACH		5
#define SYSCALL_THREAD_CANCEL		6
#define SYSCALL_THREAD_SLEEP		7
#define SYSCALL_THREAD_USLEEP		8
#define SYSCALL_THREAD_YIELD		9
#define SYSCALL_THREAD_SUSPEND		10
#define SYSCALL_THREAD_WAKEUP		11
#define SYSCALL_THREAD_FINISH_OVER	12
#define SYSCALL_THREAD_EXIT		13
#define SYSCALL_EXIT			14
#define SYSCALL_MUTEX_INIT		15
#define SYSCALL_MUTEX_DESTROY		16
#define SYSCALL_MUTEX_LOCK		17
#define SYSCALL_MUTEX_LOCK_TIMEOUT	18
#define SYSCALL_MUTEX_UNLOCK		19
#define SYSCALL_MALLOC	      		20
#define SYSCALL_FREE	      		21
#define SYSCALL_PUTC			22
#define SYSCALL_PUTS			23
#define SYSCALL_GETC			24


/* Help structures for calling syscalls with multiple parametres. */

typedef struct
{
	void * first;
	void * second;
} pair_t;

typedef struct
{
	void * first;
	void * second;
	void * third;
} trio_t;


#endif
