/**
 * @file syscall.c
 *
 * user interface for syscalls
 *
 */


#include <exc/syscall.h>


/** function causes syscall to kernel
 *
 * @param syscall_number number of syscall defined in ../syscall/syscall.h
 * @param user_data data passed from user to kernel
 * @param kernel_data data passed from kernel to user
 *
 * @return returns result of syscall
 *
 */
int syscall (unsigned long syscall_number, unsigned long arg0, unsigned long arg1, unsigned long arg2)
{
	unsigned long result           = 0;

	asm volatile(
		"syscall\n"

		"move %[result], $a0\n"
		:
		[result] "=r" (result)
		:
		/* no input */
		:
		/* nothing */
	);

	return result;
}
