/**
 * @file c.h
 *
 * C definitions file for userland.
 *
 */


#ifndef U_C_H_
#define U_C_H_

/* All right, not everything
   needs to be commented :-) */
#define false  0
#define true   (!false)

/* An unused pointer value. */
#define NULL  0

/** Basic platform types */
typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef signed short int16_t;
typedef unsigned short uint16_t;

typedef signed long int32_t;
typedef unsigned long uint32_t;

typedef signed long long int64_t;
typedef unsigned long long uint64_t;

typedef int32_t native_t;
typedef uint32_t unative_t;
typedef uint32_t uintptr_t;
typedef uint32_t off_t;
typedef uint32_t size_t;
typedef int32_t ssize_t;
typedef uint8_t bool;

typedef uint32_t ipl_t;


/** Halt the simulation
 *
 * Instructs the simulator to terminate.
 *
 */
static inline __attribute__((noreturn)) void msim_halt (void)
{
	asm volatile (
		".insn\n"
		".word 0x28\n"
	);
	
	/* This code should be unreachable since
	   the simulator is already halted.
	   
	   However, be extremely paranoid here
	   and really make sure that the CPU
	   won't execute any random code past
	   this point in the case the hell
	   freezes over. */
	while (1);
}


#endif