/**
 * @file malloc.c
 *
 * Userland memory management.
 *
 */

#include <include/c.h>
#include <librt/malloc.h>


void* malloc (const size_t size)
{
	void* ptr;
	syscall (SYSCALL_MALLOC, (unsigned long)&size, (unsigned long)&ptr, 0);
	return ptr;
}

void free (const void* ptr)
{
	void* none = 0;
	syscall (SYSCALL_FREE, (unsigned long)ptr, (unsigned long)&none, 0); 	
}
