/**
 * @file main.c
 *
 * main file for user part of kernel
 *
 */


#include <librt.h>
#include <include/c.h>


/** example function
 *
 * @return returns 0
 *
 */
int main (void);
#ifndef USER_TEST
int main (void)
{
	printf("Example of user thread.");
	
	return 0;
}
#endif


/** envelope function for main to fit it into interface
 *
 * @param data just for fitting into interface, not used
 *
 * @return returns return value of main function
 *
 */
void * main_envelope (void * data);
void * main_envelope (void * data)
{
	int result = main();
	return (void *)result;
}


/** start of first user process
 *
 * 
 */
void envelope_function (void) __attribute__((section(".start")));
void envelope_function (void)
{
	thread_t this_thread = thread_self();
	int result;
	
	if (this_thread->thread_function)
	{
		result = (int) this_thread->thread_function(this_thread->data);
	}
	else
	{
		result = (int) main_envelope(this_thread->data);
	}

	thread_finish_over(result);
	
//	msim_halt();
	
//	thread_t user_thread;
//	thread_create(&user_thread, main_envelope, 0);
//	void * result;
//	thread_join(user_thread, &result);

//	unsigned long syscallID = 0;
//	unsigned long value = 7;
//	unsigned long * valuePtr;
//	unsigned long result = syscall(syscallID, &value, (void **)(&valuePtr));

//	while (1);
	
//	msim_halt();

//	return (void *)result;

/*#ifdef USER_TEST
	main();
	msim_halt();
	return 0;
#else

	//thread_t user_thread;
	//thread_create(&user_thread, main_envelope, 0);
	//void * result;
	//thread_join(user_thread, &result);

	void* ptr = malloc( 4);
	printf( "%x", ptr);
	free( ptr);
	msim_halt();
	return 0;
	// return (void *)result;
#endif*/

}
